#ifndef ACTUATORPROVIDER_H
#define ACTUATORPROVIDER_H

#include "Channel.h"
#include "XProvider.h"
#include "btBulletDynamicsCommon.h"

class ActuatorProvider : public XProvider
{
private:
	btHingeConstraint *m_joint;
	int m_orient;
	btScalar computeVelocity(btScalar currentAngle, btScalar targetAngle);

public:
	ActuatorProvider(Channel *chan, btHingeConstraint *joint, int orient);
	~ActuatorProvider();

	btHingeConstraint *getConstraint();
	int getOrient();

	void updatePost();

	void packData(channelData *data, int id);
};

#endif //ACTUATORPROVIDER_H
