#ifndef CHANNEL_H
#define CHANNEL_H

#include <mpi.h>
#include <sys/types.h>
#include "constants.h"

typedef struct {
	int tag;
	int type;
	int orient;
	int dest;
	float minAngle;
	float maxAngle;
	float angle;
} channelData;

typedef MPI_Datatype channel_datatype_t;

class Channel
{

public:
	Channel();
	~Channel();

	virtual int read(void *buf, channel_datatype_t datatype, size_t count);
	virtual int write(const void *buf, channel_datatype_t datatype, size_t count);
	virtual int available();

};

#endif // CHANNEL_H

