#ifndef SIMPLEDEMO_H
#define SIMPLEDEMO_H

#include "GLDebugDrawer.h"
#include "GlutDemoApplication.h"
#include <LinearMath/btAlignedObjectArray.h>
#include <utility>

using namespace std;

class btBroadphaseInterface;
class btCollisionShape;
class btOverlappingPairCache;
class btCollisionDispatcher;
class btConstraintSolver;
struct btCollisionAlgorithmCreateFunc;
class btDefaultCollisionConfiguration;

///BasicDemo is good starting point for learning the code base and porting.
class SimpleDemo : public GlutDemoApplication
{
	//keep the collision shapes, for deletion/cleanup
	btAlignedObjectArray<btCollisionShape*>	m_collisionShapes;
	btBroadphaseInterface*	m_broadphase;
	btCollisionDispatcher*	m_dispatcher;
	btConstraintSolver*	m_solver;
	btDefaultCollisionConfiguration* m_collisionConfiguration;

public:

	SimpleDemo()
	{
	}
	virtual ~SimpleDemo()
	{
		exitPhysics();
	}

	void initPhysics();
	void exitPhysics();

	void debug();
	virtual void clientMoveAndDisplay();
	virtual void displayCallback();

	static LocalGui* Create()
	{
		SimpleDemo* demo = new SimpleDemo;
		demo->myinit();
		demo->initPhysics();
		return demo;
	}
};

#endif //SIMPLEDEMO_H

