#include <stdio.h>
#include "DemoApplication.h"
#include "GuiUpdater.h"
#include <BulletDynamics/Dynamics/btRigidBody.h>

#include <pthread.h>

typedef struct {
	DemoApplication *demo;
	int argc;
	char **argv;
} threadParam;

void *guiThreadCode(void *args)
{
	threadParam *param = (threadParam*)args;

	DemoApplication *vworld = param->demo;
	char **argv = param->argv;
	int argc = param->argc;

	int ret = glutmain(argc, argv, 640, 480, "SIMEO GUI", vworld);

	if(ret < 0)
		printf("Error launching glutmain\n");

	return NULL;
}

int main(int argc, char *argv[])
{
	printf("SimeoGui\n");

	if (argc != 3) {
		fprintf(stderr, "Usage: %s <host> <port>\n", argv[0]);
		return 1;
	}

	pthread_t guiThread;
	threadParam param;

	DemoApplication *demo = new DemoApplication();

	param.demo = demo;
	param.argc = argc;
	param.argv = argv;

	GuiUpdater *updater = new GuiUpdater(atoi(argv[2]), gethostbyname(argv[1]));

	pthread_create(&guiThread, NULL, guiThreadCode,	&param);

	updater->init();

	while (1) {
		updater->update();
		demo->updateInfo(updater->m_cache);
	}

	return 0;
}
